#include "FrustumCullingManager.h"
#include <OgreLogManager.h>

namespace GtpVisibility {

//-----------------------------------------------------------------------
void FrustumCullingManager::RenderScene()
{
	//InitFrame();
	
	while (!mHierarchyInterface->GetQueue()->empty())
	{
		if (mHierarchyInterface->mDummy)
			Ogre::LogManager::getSingleton().logMessage("shadow pass");
	//	elseOgre::LogManager::getSingleton().logMessage("no shadow pass");
		HierarchyNode *node = mHierarchyInterface->GetQueue()->top();
		mHierarchyInterface->GetQueue()->pop();
		
		// interesting for visualization purpose
		mHierarchyInterface->SetNodeVisible(node, false);
		mHierarchyInterface->SetLastVisited(node, mHierarchyInterface->GetFrameId());

		if (!mHierarchyInterface->CheckFrustumVisible(node))
		{if (mHierarchyInterface->mDummy)
			mNumFrustumCulledNodes ++;
		}
		else
		{		
			mHierarchyInterface->SetNodeVisible(node, true);
			mHierarchyInterface->TraverseNode(node);
		}
	}
}

} // namespace GtpVisibility
